-- Table structure for table `currencies`
--

DROP TABLE IF EXISTS `currencies`;
CREATE TABLE IF NOT EXISTS `currencies` (
  `currencies_id` int(11) NOT NULL auto_increment,
  `title` varchar(32) collate utf8_unicode_ci NOT NULL default '',
  `code` char(3) collate utf8_unicode_ci NOT NULL default '',
  `symbol_left` varchar(24) collate utf8_unicode_ci default NULL,
  `symbol_right` varchar(24) collate utf8_unicode_ci default NULL,
  `decimal_point` char(1) collate utf8_unicode_ci default NULL,
  `thousands_point` char(1) collate utf8_unicode_ci default NULL,
  `decimal_places` char(1) collate utf8_unicode_ci default NULL,
  `decimal_precise` char(1) collate utf8_unicode_ci NOT NULL default '2',
  `value` float(13,8) default NULL,
  `last_updated` datetime default NULL,
  PRIMARY KEY  (`currencies_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=5 ;

--
-- Dumping data for table `currencies`
--

INSERT INTO `currencies` (`currencies_id`, `title`, `code`, `symbol_left`, `symbol_right`, `decimal_point`, `thousands_point`, `decimal_places`, `decimal_precise`, `value`, `last_updated`) VALUES
(1, 'US Dollar', 'USD', '$', '', '.', ',', '2', '6', 1.00000000, '2011-03-15 05:15:30'),
(3, 'Quetzal', 'GTQ', 'Q', '', '.', '', '2', '6', 7.86000013, NULL),
(4, 'Lempira', 'HNL', 'L', '', '.', '', '2', '6', 19.45689964, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `tax_authorities`
--

DROP TABLE IF EXISTS `tax_authorities`;
CREATE TABLE IF NOT EXISTS `tax_authorities` (
  `tax_auth_id` int(3) NOT NULL auto_increment,
  `type` varchar(1) collate utf8_unicode_ci NOT NULL default 'c',
  `description_short` char(15) collate utf8_unicode_ci NOT NULL default '',
  `description_long` char(64) collate utf8_unicode_ci NOT NULL default '',
  `account_id` char(15) collate utf8_unicode_ci NOT NULL default '',
  `vendor_id` int(5) NOT NULL default '0',
  `tax_rate` float NOT NULL default '0',
  PRIMARY KEY  (`tax_auth_id`),
  KEY `description_short` (`description_short`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=4 ;

--
-- Dumping data for table `tax_authorities`
--

INSERT INTO `tax_authorities` (`tax_auth_id`, `type`, `description_short`, `description_long`, `account_id`, `vendor_id`, `tax_rate`) VALUES
(1, 'c', 'DEI-HN', 'DEI - Honduras', '2220', 0, 12),
(2, 'c', 'SAT-GT', 'SAT - Guatemala', '2210', 0, 12),
(3, 'v', 'SAT', 'SAT-GT', '2210', 66, 12);

-- --------------------------------------------------------

--
-- Table structure for table `tax_rates`
--

DROP TABLE IF EXISTS `tax_rates`;
CREATE TABLE IF NOT EXISTS `tax_rates` (
  `tax_rate_id` int(3) NOT NULL auto_increment,
  `type` varchar(1) collate utf8_unicode_ci NOT NULL default 'c',
  `description_short` varchar(15) collate utf8_unicode_ci NOT NULL default '',
  `description_long` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `rate_accounts` varchar(64) collate utf8_unicode_ci NOT NULL default '',
  `freight_taxable` enum('0','1') collate utf8_unicode_ci NOT NULL default '0',
  PRIMARY KEY  (`tax_rate_id`),
  KEY `description_short` (`description_short`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=4 ;

--
-- Dumping data for table `tax_rates`
--

INSERT INTO `tax_rates` (`tax_rate_id`, `type`, `description_short`, `description_long`, `rate_accounts`, `freight_taxable`) VALUES
(1, 'c', 'IVA GT', 'IVA Guatemala', '2', '0'),
(2, 'c', 'IVA HN', 'IVA Honduras', '1', '0'),
(3, 'v', 'SAT-GT', 'SAT-GT', '3', '0');


