<?php
/*
 Reportico - PHP Reporting Tool
 Copyright (C) 2010-2011 Peter Deed

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 * File:        run.php
 *
 * Reportico runner script
 * !!! Note this script will run reports in FULL design mode
 * !!! This means that users of the reports will be able to 
 * !!! modify reports and save those modifications
 *
 * @link http://www.reportico.org/
 * @copyright 2010-2011 Peter Deed
 * @author Peter Deed <info@reportico.org>
 * @package Reportico
 * @version $Id: partial.php,v 1.3 2012-01-26 19:49:41 peter Exp $
 */

    // Set the level of error reporting
    error_reporting(E_ALL & ~E_NOTICE);
    // set php_self in the local scope
    if (!isset($PHP_SELF)) $PHP_SELF = $_SERVER['PHP_SELF'];
    // Check for application configuration parameters, may be preloaded in running from a subdirectory, so skip
    // currently scripts run from top level (index.php only) and second level, so we only need to check these two levels
    if (!defined('DIR_FS_ADMIN')) {
    if (file_exists('../../../../includes/configure.php')) {
        require_once('../../../../includes/configure.php');
    } else {
        die('ERROR: includes/configure.php file not found on PhreeBooks Server.');
    }
    }
    
    // load some file system constants
    define('DIR_FS_MODULES',   DIR_FS_ADMIN . 'modules/');
    define('DIR_FS_MY_FILES',  DIR_FS_ADMIN . 'my_files/');
    define('FILENAME_DEFAULT', 'index');

    // set error reporting level
	error_reporting(E_ALL);

    // Set the timezone according to system defaults
    date_default_timezone_set(@date_default_timezone_get());

    // Reserver 100Mb for running
	ini_set("memory_limit","100M");

	//ob_start();
	require_once('reportico.php');
	$q = new reportico();

    // determine what company to connect to
    $db_name = false;
    if ( isset ( $_GET['db'] ) )
        $db_name = $_GET['db'];
    $db_name = session_request_item("phreedom_db", $db_name);
    if ($db_name && file_exists(DIR_FS_MY_FILES . $db_name . '/config.php')) {
        define('DB_DATABASE', $db_name);
        require(DIR_FS_MY_FILES . $db_name . '/config.php');
        if ( defined("DB_SERVER") )
            define('DB_SERVER_HOST',DB_SERVER); // for old PhreeBooks installs
    } else {
        echo 'No database name passed. Cannot determine which company to connect to!';
        exit();
    }

    // Set reportico db connection details from Phreedom connection params
    if ( $q->get_execute_mode() != "ADMIN" )
    {
        // Set reportico db connection details from Phreedom connection params
        define('SW_DB_DRIVER','pdo_mysql');
        define('SW_DB_USER',DB_SERVER_USERNAME);
        define('SW_DB_PASSWORD',DB_SERVER_PASSWORD);
        define('SW_DB_HOST',DB_SERVER_HOST);
        define('SW_DB_DATABASE',$db_name);
    }


	$q->allow_debug = true;
	$q->forward_url_get_parameters = "";
	$q->embedded_report = true;
	$q->execute($q->get_execute_mode(), true);
	//ob_end_flush();
?>
